#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>


#include "opSem.h"

#include "description.h"

#define NBTOURS 5

void procFils(int sem_id)
{
 int i;
 for(i=0; i<NBTOURS; i++)
 {
  P(sem_id,MUTEX);

    printf("Dans le fils, pid: %d\n", getpid());
    system("less livre");

  V(sem_id,MUTEX);
 }
}

void procPere(int sem_id)
{
 int i;
 for(i=0; i<NBTOURS; i++)
 {
  P(sem_id,MUTEX);

    printf("Dans le pere, pid: %d\n", getpid());
    system("less livre");

  V(sem_id,MUTEX);
 }
}

int main(void)
{
 key_t    sem_cle;
 int      sem_id;

 pid_t    pid;

 /* Initialisation du semaphore */

 sem_cle = IPC_PRIVATE;
 if (sem_cle == -1) { perror("ftok"); exit(EXIT_FAILURE); }

 sem_id  = semget(sem_cle, SEMNBR, IPC_CREAT | IPC_EXCL | 0666);
 if (sem_id == -1) { perror("semget"); exit(EXIT_FAILURE); }

 semctl(sem_id, MUTEX, SETVAL, INIVAL); /* Init du semaphore MUTEX */

 pid = fork();

 switch (pid)
 {
  case -1 : perror("fork");
            exit(EXIT_FAILURE);
            break;
  case  0 : procFils(sem_id);
            exit(EXIT_SUCCESS);
            break;
  default : procPere(sem_id);
            break;
 }

 wait(NULL);

 semctl (sem_id, SEMNBR , IPC_RMID, NULL);

 return EXIT_SUCCESS;
}
