
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <errno.h>
#include <stdio.h>

void selectExample(int * fdArray,size_t nbFd)
{
 size_t i;
 int fdMax=-1;
 fd_set rdFds;
 struct timeval timeout;
 int result;

 FD_ZERO(&rdFds);
 for(i=0;i<nbFd;i++)
 {
  FD_SET(fdArray[i],&rdFds);
  if(fdArray[i]>fdMax) fdMax=fdArray[i];
 }

 timeout.tv_sec=10; /* attente de 10 secondes */
 timeout.tv_usec=0; /*   et 0 microsecondes   */
 do
 {
  result=select(fdMax+1,&rdFds,(fd_set *)0,(fd_set *)0,&timeout);
 } while((result==-1)&&(errno==EINTR));

 switch(result)
 {
  case -1:
    fprintf(stderr,"Pb in select !\n");
    break;
  case 0:
    fprintf(stderr,"Timeout in select !\n");
    break;
  default:
    for(i=0;i<nbFd;i++)
    {
     if(FD_ISSET(fdArray[i],&rdFds))
        fprintf(stderr,"I can read from %d\n",fdArray[i]);
    }
 }
}

